package cn.com.qmth.stmms.ms.admin.exporter;

import cn.com.qmth.stmms.ms.admin.assembler.MarkUserAssembler;
import cn.com.qmth.stmms.ms.admin.dto.MarkUserDTO;
import cn.com.qmth.stmms.ms.commons.utils.excel.ExportUtils;
import cn.com.qmth.stmms.ms.core.domain.user.MarkUser;
import cn.com.qmth.stmms.ms.core.repository.MarkUserRepo;
import cn.com.qmth.stmms.ms.core.vo.Subject;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletResponse;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Stream;

/**
 * 导出用户信息
 * Created by zhengmin on 2016/11/18.
 */
@RestController
@RequestMapping("export/users")
public class UserExporter {

    @Autowired
    private MarkUserRepo markUserRepo;

    @Autowired
    private MarkUserAssembler markUserAssembler;

    @RequestMapping(method = RequestMethod.GET)
    public void export(@RequestParam Long workId, @RequestParam(required = false) Subject subject,HttpServletResponse response){
        List<MarkUserDTO> markUserDTOs = new ArrayList<>();
        Stream<MarkUser> markUserStream = markUserRepo.findByWorkId(workId).stream();
        if(subject != null){
            markUserStream = markUserStream.filter(u -> u.getSubject() == subject);
        }
        markUserStream.forEach(u -> {
            markUserDTOs.add(markUserAssembler.toDTO(u));
        });
        String fileName = "用户列表";
        ExportUtils.exportEXCEL(fileName,MarkUserDTO.class,markUserDTOs,response);
    }
}
