package cn.com.qmth.stmms.ms.collect.api;

import cn.com.qmth.stmms.ms.commons.config.SystemConfig;
import cn.com.qmth.stmms.ms.commons.utils.image.ImageCompression;
import cn.com.qmth.stmms.ms.core.domain.Paper;
import cn.com.qmth.stmms.ms.core.repository.PaperRepo;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.*;

import javax.imageio.ImageIO;
import java.awt.image.BufferedImage;
import java.io.*;
import java.nio.file.Path;
import java.nio.file.Paths;

/**
 * Created by zhengmin on 2017/2/24.
 */
@RestController
@RequestMapping("api/images")
public class ImageApi {

    @Autowired
    private PaperRepo paperRepo;

    @Autowired
    private SystemConfig systemConfig;

    @RequestMapping(value = "{paperId}/rotate",method = RequestMethod.GET)
    public ResponseEntity rotate(@PathVariable Long paperId,
                                 @RequestParam int degree){
        Paper paper = paperRepo.findOne(paperId);
        Path thumbPath = Paths.get(systemConfig.getThumbDir(),String.valueOf(paper.getWorkId()),paper.getSubject().toString(),paper.getAreaCode(),paper.getExamNumber() + ".jpg");
        Path imagePath = Paths.get(systemConfig.getImageDir(),String.valueOf(paper.getWorkId()),paper.getSubject().toString(),paper.getAreaCode(),paper.getExamNumber() + ".jpg");
        try {
            File thumbFile = thumbPath.toFile();
            if(thumbFile.exists()) {
                InputStream is = new FileInputStream(thumbFile);
                BufferedImage image = ImageIO.read(is);
                ImageCompression.rotate(thumbFile, thumbFile, degree);
                is.close();
            }
            File imageFile = imagePath.toFile();
            if(imageFile.exists()){
                InputStream is = new FileInputStream(imageFile);
                BufferedImage image = ImageIO.read(is);
                ImageCompression.rotate(imageFile, imageFile, degree);
                is.close();
            }
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException ioe){
            ioe.printStackTrace();
        }
        return new ResponseEntity(HttpStatus.OK);
    }
}
